<?xml version="1.0" encoding="UTF-8"?>
<jube>
    <parameterset name="compileset">
        <parameter name="make">make</parameter>
        <parameter name="cc">gcc</parameter>
        <parameter name="cflags"></parameter>
        <parameter name="mpi_cc">mpicc</parameter>
        <parameter name="mpi_cxx">mpic++</parameter>
        <parameter name="mpi_f90">mpif90</parameter>
        <parameter name="mpi_f77">mpif77</parameter>
    </parameterset>

    <parameterset name="libs">
        <parameter name="load_module">module load</parameter>
    </parameterset>

<!-- parameterset for the submission -->  
    <parameterset name="executeset">
        <parameter name="starter" mode="python">
	        { "no"  : "srun"   ,
		  "yes" : "mpirun" }["$gpuoffload"]</parameter>
        <parameter name="args_starter">  </parameter>
        <parameter name="submit">sbatch</parameter>
	<parameter name="submit_script" mode="python">
		{ "no"  : "submit_cpu.job"  ,
		  "yes" : "submit_gpu.job" }["$gpuoffload"]</parameter>
        <parameter name="shared_folder">shared</parameter>
        <parameter name="shared_job_info">${shared_folder}/jobid</parameter>
        <parameter name="done_file">ready</parameter>
    </parameterset>

<!-- default parameters for the scheduler -->
    <parameterset name="systemParameter">
        <parameter name="timelimit">00:30:00</parameter>
	<parameter name="nodes">1</parameter>
	<parameter name="ncores" type="int">48</parameter>
	<parameter name="nsockets" type="int">2</parameter>
        <parameter name="taskspernode" >1</parameter>
	<parameter name="taskspersocket" mode="python" type="int">int(max(1,$taskspernode/$nsockets))</parameter>
        <parameter name="cpuspertask" mode="python" type="int">24 // $taskspersocket</parameter>
        <parameter name="threadspertask">$cpuspertask</parameter>
        <parameter name="outlogfile">job.out</parameter>
	<parameter name="errlogfile">job.err</parameter>
	<parameter name="gpuoffload" >no</parameter>
	<parameter name="queue">g100_usr_prod</parameter>
	<parameter name="qos"  mode="python"><!-- queue  -->
		{ False : "normal" ,
		  True  : "g100_qos_bprod" }[bool($nodes>32)]
	</parameter>
        <parameter name="env" separator=";">$jube_wp_envstr</parameter>
	<parameter name="gres" separator=";">gpu:1</parameter>
        <!--parameter name="pe" mode="python" type="int">
          16//$taskspersocket
        </parameter-->
        <parameter name="tasks" mode="python" type="int">
          $nodes * $taskspernode
        </parameter>
	<parameter name="memnodemachine">350GB</parameter>
    </parameterset>

<!-- replacements from the specific application xml -->
    <substituteset name="executesub">
        <iofile in="$submit_script" out="$submit_script" />
        <sub source="#BENCHNAME#" dest="$jube_benchmark_name" />
        <sub source="#QUEUE#" dest="$queue" />
        <sub source="#TIME_LIMIT#" dest="$timelimit" />
        <sub source="#PREPROCESS#" dest="" />
        <sub source="#POSTPROCESS#" dest="" />
        <sub source="#STARTER#" dest="$starter" />
        <sub source="#ARGS_STARTER#" dest="$args_starter" />
        <sub source="#MEASUREMENT#" dest="" />
        <sub source="#STDOUTLOGFILE#" dest="$outlogfile" />
        <sub source="#STDERRLOGFILE#" dest="$errlogfile" />
        <sub source="#EXECUTABLE#" dest="$executable" />
        <sub source="#ARGS_EXECUTABLE#" dest="$args_executable" />
        <sub source="#FLAG#" dest="touch $done_file" />
        <sub source="#NODES#" dest="$nodes" />
        <sub source="#THREADSPERTASK#" dest="$threadspertask" />
        <sub source="#TASKSPERNODE#" dest="$taskspernode" />
        <sub source="#TASKSPERSOCKET#" dest="$taskspersocket" />
        <sub source="#CPUSPERTASK#" dest="$cpuspertask" />
	<!--sub source="#PE" dest="$pe" /-->
        <sub source="#GRES#" dest="$gres" />
        <sub source="#ACCOUNT_NO#" dest="$accountno" />
        <sub source="#QOS#" dest="$qos" />
        <sub source="#PREPROCESS#" dest="$modules" />
    </substituteset>

    <substituteset name="chainsub">
    </substituteset>

<!-- copy of the template for the submission from the root into the local dir --> 
    <fileset name="jobfiles">
        <copy>$submit_script</copy>
    </fileset>

</jube>
